#!/usr/bin/perl

##
# by Thomas Koch <tom@linvdr.org>
##
# modifiziert fuer hardware-wakeup nach Frank Jepsen
# Pfad fr shutdown90.wakeup-module.sh eventuell anpassen
# in shutdown90.wakeup-module.sh KILL_LIRC=no setzen
# und gegebenenfalls WAKEUP_PORT ndern

use POSIX qw(strftime sprintf);

my $DEBUG = 0;

system(sprintf("logger -s \"Start Poweroff.pl\n\""));
system("killall lircd");
sleep(2);
system("rmmod lirc_serial");
sleep(2);
system("modprobe 8250");
sleep(2);

sub dprint {
  $_ = join("", @_);
  chomp;
  print "$_\n" if($DEBUG);
}

sub setTime {
  system("hwclock -w"); 
}  

sub setAlarm {
  my $Next = shift;
  system(sprintf("logger -s \" Set Alarm\n\""));
  
  system(sprintf("/etc/vdr/shutdown90.wakeup-module.sh %s", $Next));
}

sub PowerOff {
  system(sprintf("logger -s \" End poweroff.pl, calling busybox\n\""));
  #exit(1);
  system("/bin/busybox poweroff") if(!$DEBUG);
}

if(scalar(@ARGV)) {
  # called from vdr
  system(sprintf("logger -s \" Check %d Args\n\"", scalar(@ARGV) ));
  die "Wrong parameter count\n" if(scalar(@ARGV) != 5);

  my($Next, $Delta, $Channel, $Recording, $UserShutdown) = @ARGV;
  system(sprintf("logger -s \" Args %d %d %d \"%s\" %d\n\"", $Next, $Delta, $Channel, $Recording, $UserShutdown ));
  
  setAlarm($Next) if($Next);
  PowerOff();
} else {
  # called from cmdline
  $next = `svdrpsend.pl next abs`;
  if($next =~ /550 No active timers/) {
    # XXX turns alarm off, at least, i hope so
    #system("echo \"0003-10-20 99:00:00\" > /proc/acpi/alarm"); 
    setTime();
    PowerOff();
  } elsif($next =~ /250 \d+ (\d+)/) {
    setAlarm($1);
    PowerOff();
  } else {
    print "HELP! What to do? ($next)\n";
  }
}	
